package nasa.stps.clients;
import nasa.stps.server.StpsServices;

/**
 * A program to terminate the server.
 * @author Stan Hilinski, june 2001
 */
public class Kill
{
    public static void main(String args[])
    {
        String host = (args.length > 0)? args[0] : "localhost";

        String target = "//" + host + "/StpsServices";
        if (args.length == 2)
        {
            target += "." + args[1];
        }
        

        try
        {
            StpsServices server = (StpsServices)java.rmi.Naming.lookup(target);
            server.stopServer();
            System.exit(0);
        }
        catch (java.rmi.UnmarshalException uex)
        {
            //normal because the server probably won't answer.
            System.exit(0);
        }
        catch (Exception ex)
        {
            System.err.println("Lookup error. "+target);
            System.err.println(ex);
            System.exit(100);
        }
    }
}