package nasa.stps.core;

/**
 * Any class that implements FrameReceiver accepts frames from a FrameSender.
 * @author Stan Hilinski, December, 2000
 */
public interface FrameReceiver extends Receiver
{
    /**
     * Give a frame to this FrameReceiver.
     */
    public void putFrame(Frame frame) throws StpsException;

    /**
     * Give an array of frames to this FrameReceiver.
     */
    public void putFrames(Frame[] frames) throws StpsException;

    /**
     * Flush the data pipeline.
     */
    public void flush() throws StpsException;

    /**
     * Get this receiver's name (for error messages).
     */
    public String getLinkName();
}