package nasa.stps.core;

/**
 * This is a base interface to FrameReceiver, PacketReceiver, and
 * UnitReceiver. A Receiver object accepts frames, packets, or units from
 * a Sender.
 * @author Stan Hilinski, March, 2001
 */
public interface Receiver
{
    /**
     * Flush the data pipeline.
     */
    public void flush() throws StpsException;

    /**
     * Get this receiver's name (for error messages).
     */
    public String getLinkName();
}