package nasa.stps.core;

/**
 * A Sender sends a type of unit (packets, frames, or units) to one or more
 * receivers.
 * @author Stan Hilinski, March, 2001
 */
public interface Sender
{
    /**
     * Add a Receiver to this sender's list of receivers.
     * @param node If the receiver is not of the expected type,
     *          then the method throws an StpsException.
     */
    public void addReceiver(Receiver receiver) throws StpsException;
}