package nasa.stps.core.ccsds;
import java.util.Iterator;
import nasa.stps.core.StpsException;

/**
 * StpsNodes that send packets to PacketReceivers use this class to broadcast
 * packets to more than one PacketReceiver.
 * @author Stan Hilinski, March 2001
 */
public class PacketBroadcaster extends nasa.stps.core.Broadcaster
        implements PacketReceiver
{
    /**
     * Create a PacketBroadcaster.
     */
    public PacketBroadcaster(String name, PacketReceiver pr1, PacketReceiver pr2)
    {
        super(name,pr1,pr2);
    }

    /**
     * Give an array of packets to this PacketReceiver.
     */
    public void putPackets(Packet[] packets) throws StpsException
    {
        Iterator i = output.iterator();
        while (i.hasNext())
        {
            PacketReceiver pr = (PacketReceiver)i.next();
            pr.putPackets(packets);
        }
    }

    /**
     * Give a packet to this PacketReceiver.
     */
    public void putPacket(Packet packet) throws StpsException
    {
        if (!packet.isDeleted())
        {
            Iterator i = output.iterator();
            while (i.hasNext())
            {
                PacketReceiver pr = (PacketReceiver)i.next();
                pr.putPacket(packet);
            }
        }
    }
}