package nasa.stps.core.ccsds;

/**
 * Any class that implements PacketReceiver accepts packets from a PacketSender.
 * @author Stan Hilinski, December 2000
 */
public interface PacketReceiver extends nasa.stps.core.Receiver
{
    /**
     * Give an array of packets to this PacketReceiver.
     */
    public void putPackets(Packet[] packets) throws nasa.stps.core.StpsException;

    /**
     * Give a packet to this PacketReceiver.
     */
    public void putPacket(Packet packet) throws nasa.stps.core.StpsException;

    /**
     * Flush the data pipeline.
     */
    public void flush() throws nasa.stps.core.StpsException;

    /**
     * Get this receiver's name (for error messages).
     */
    public String getLinkName();
}