package nasa.stps.core.fs.clock;

/**
 * This interface is the timer for the frame annotation timetag.
 * @author Stan Hilinski, March 2001
 */
public interface FrameClock
{
    /**
     * Start the clock. This is really only important for clocks that use
     * the current time.
     */
    public void start();

    /**
     * Get a timestamp. For some clocks you must call this method to advance
     * the time.
     */
    public long getTimeStamp();
}