package nasa.stps.core.output;

/**
 * This is the base class for all RTSTPS devices. It should probably
 * have extended DataOutputStream instead of using containment, and
 * I no doubt someday do just that. I did it this way originally
 * because I wanted more flexibility on the nature of output devices.
 * @author Stan Hilinski, July 2001
 */
abstract class AbstractOutputDevice
{
    protected java.io.DataOutputStream output = null;

    final java.io.DataOutputStream getOutputStream()
    {
        return output;
    }

    abstract void shutdown() throws nasa.stps.core.StpsException;
}