package nasa.stps.core.output;
import nasa.stps.core.*;
import nasa.stps.core.ccsds.*;

/**
 * This is a null channel. It discards everything.
 * @author Stan Hilinski, July 2001
 */
public final class NullChannel extends StpsNode implements Cloneable,
        FrameReceiver, UnitReceiver, PacketReceiver
{
    public static final String CLASSNAME = "null";

    /**
     * Set up this stps node with a configuration.
     */
    public void load(org.w3c.dom.Element element, Configuration configuration)
            throws StpsException
    {
        super.setLinkName(element.getAttribute("label"));
    }

    public NullChannel()
    {
        super(CLASSNAME);
    }

    /**
     * Finish the setup. When this method is called, you may assume all nodes
     * have been created and exist by name in the map, and all standard links
     * have been resolved. This is a last chance to prepare for data flow.
     */
    public void finishSetup(Configuration configuration)
            throws StpsException
    {
    }

    /**
     * Flush the output channel.
     */
    public void flush() throws StpsException
    {
    }

    /**
     * Give an array of frames to this FrameReceiver.
     */
    public void putFrames(Frame[] frames) throws StpsException
    {
    }

    /**
     * Give a frame to this FrameReceiver.
     */
    public void putFrame(Frame frame) throws StpsException
    {
    }

    /**
     * Give a unit to this UnitReceiver.
     */
    public void putUnit(Unit unit) throws StpsException
    {
    }

    /**
     * Give an array of units to this UnitReceiver.
     */
    public void putUnits(Unit[] units) throws StpsException
    {
    }

    /**
     * Give an array of packets to this PacketReceiver.
     */
    public void putPackets(Packet[] packets) throws nasa.stps.core.StpsException
    {
    }

    /**
     * Give a packet to this PacketReceiver.
     */
    public void putPacket(Packet packet) throws nasa.stps.core.StpsException
    {
    }
}

