package nasa.stps.core.xstps.hrit;

import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.util.Iterator;

import javax.imageio.stream.FileImageOutputStream;

/**
 * Thread subclass that handles JPEG decoding from a PipedInputStream.
 */

public class HRITJpegDecoder extends Thread {

    /**
     * InputStream that the data is decoded from.
     */
    private PipedInputStream in = null;
    //private BufferedInputStream bis = null;
    private String fileName = null;
    private int bytesToSkip = -1;
    private String path = null;

    public HRITJpegDecoder(PipedOutputStream pos, String curFileName, int headersLength, String path) throws IOException {
        in = new PipedInputStream(pos);
    	//bis = new BufferedInputStream(in);
        fileName = curFileName;
        bytesToSkip = headersLength;
        this.path = path;
    }

    public void run() {
    	try {
    		System.err.println("Starting JPEG decoder...");
    		LosslessJpeg lj = new LosslessJpeg();
			File f = new File(path, fileName);
			FileImageOutputStream fios = new FileImageOutputStream(f);
			fios.skipBytes(bytesToSkip);    		
    		int rc = lj.ljpeg(in, fios);
    		System.err.println("JPEG decoder completes...");
    		if (rc != 0) {
    			System.err.println("JPEG Decoder ERROR!, return code: " + rc);
    		}
			fios.flush();
			fios.close();
			// now that we're done, take the temporary prefix off beginning of file name
			boolean rename = f.renameTo(new File(path, fileName.substring(OutputFiles.IN_PROGRESS_PREFIX.length(), fileName.length())));
			if (rename) {
				System.err.println("File " + f.getName().substring(OutputFiles.IN_PROGRESS_PREFIX.length(), fileName.length()) + " is complete...");
			} else {
				System.err.println("Error: Unable to rename file " + f.getName());
			}	
			in.close();
			// encourage garbage collection after each segment.  Normally I stay
			// away from this, but JProfiler showed it was actually useful here!
			System.gc();
    	} catch (Exception e) {
    		System.err.println("Error: problem decoding JPEG data, details follow: ");
    		e.printStackTrace();  
    	}
/*    	try {
    		ImageInputStream iis = ImageIO.createImageInputStream(in);
    		Iterator iterator = ImageIO.getImageReaders(iis);
    		if (iterator.hasNext()) {
    			ImageReader ir = (ImageReader) iterator.next();
    			ir.setInput(iis, true);
    			ir.addIIOReadProgressListener(this);
    			BufferedImage bi = ir.read(0);
    			Raster r = bi.getData();
    			short [] imageDataTwoByte = null;
    			byte [] imageDataOneByte = null;
    			// real image data is two-byte, overlay is one-byte
    			if (fileName.indexOf("IMG_") >= 0) {
    				imageDataTwoByte = (short []) r.getDataElements(0, 0, r.getWidth(), r.getHeight(), null);
    			} else {
    				imageDataOneByte = (byte []) r.getDataElements(0, 0, r.getWidth(), r.getHeight(), null);
    			}
    			File f = new File(path, fileName);
    			FileImageOutputStream fios = new FileImageOutputStream(f);
    			fios.skipBytes(bytesToSkip);

    			// real image data is two-byte, overlay is one-byte
    			if (fileName.indexOf("IMG_") >= 0) {
    				fios.writeShorts(imageDataTwoByte, 0, imageDataTwoByte.length);
    			} else {
    				fios.write(imageDataOneByte, 0, imageDataOneByte.length);
    			}
    			fios.flush();
    			fios.close();
    			// now that we're done, take the temporary prefix off beginning of file name
    			boolean rename = f.renameTo(new File(path, fileName.substring(OutputFiles.IN_PROGRESS_PREFIX.length(), fileName.length())));
    			if (rename) {
    				System.err.println("File " + f.getName().substring(OutputFiles.IN_PROGRESS_PREFIX.length(), fileName.length()) + " is complete...");
    			} else {
    				System.err.println("Error: Unable to rename file " + f.getName());
    			}	
    			
    			// null all major objects out to encourage garbage collection - this is the best place to do it.
    			imageDataTwoByte = null;
    			imageDataOneByte = null;
    			r = null;
    			bi = null;
    			ir.dispose();
    			ir = null;
    			System.gc();

    		} else {
    			System.err.println("Error: Unable to create Iterator of ImageReader objects.");
    		}
    	} catch (IOException ioe) {
    		System.err.println("Error: problem decoding JPEG data, details follow: ");
    		ioe.printStackTrace();       		
    	}*/
    }

}

