package nasa.stps.core.xstps.hrit;

import java.awt.image.Raster;

import java.io.InputStream;
import java.io.IOException;

import java.util.Iterator;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;

import javax.imageio.stream.ImageInputStream;

public class HritImageReader extends Thread {
    private ImageReader ir = null;
    private InputStream is = null;
    //private Raster r = null;

    public HritImageReader(InputStream is) {
    	this.is  = is;
    }

    public void run() {
    	System.out.println("Image reader thread started...");
        if (is != null) {
        	try {
	        	System.out.println("Creating ImageInputStream...");
	        	ImageInputStream iis = ImageIO.createImageInputStream(is);
	        	Iterator iterator = ImageIO.getImageReaders(iis);
	        	if (iterator.hasNext()) {
	        		ir = (ImageReader) iterator.next();
	        		ir.setInput(iis, true);
	        		//r = ir.readRaster(0, null);
	        	}
        	} catch (IOException ioe) {
        		System.err.println("IOException in HritImageReader: " + ioe);
        	}
        }
    }
    
    public Raster getRaster() {
    	Raster r = null;
    	try {
    		r = ir.readRaster(0, null);
    	} catch (IOException ioe) {
    		System.err.println("IOException in HritImageReader.getRaster(): " + ioe);
    	}
    	return r;
    }

}