package nasa.stps.server;

import java.io.*;

/**
 * This class logs server events. It writes timetagged messages to the monitor
 * screen and to the file stps.log if it is enabled.
 * @author Stan Hilinski, July 2002.
 */

class Logger
{
    private java.io.PrintWriter log;

    Logger()
    {
        try
        {
            log = new PrintWriter(new FileOutputStream("stps.log"),true);
        }
        catch (FileNotFoundException fnfe)
        {
            System.out.println("Cannot open stps.log");
            System.exit(1);
        }
    }

    void print(String message)
    {
        // TJJ : for now, since we're logging everything through JSW,
    	// just redirect the RT-STPS logger to send the message to standard out
        System.out.println(message);
        // log.println(text);
    }

    void close()
    {
        print("The server exits.");
        log.close();
    }
}