package nasa.stps.viewer;
import nasa.stps.core.status.StatusItem;
import javax.swing.*;
import java.awt.*;

/**
 * TextGadget is a visual component that shows a status item label
 * and its value.
 * @author Stan Hilinski, August 2001
 */
class TextGadget extends AbstractTextGadget
{
    /**
     * Create a TextGadget with a label.
     * @param label A label to be shown on the screen.
     * @param fullIdentity The full status identification of the item.
     */
    TextGadget(String label, String fullIdentity)
    {
        super(label, fullIdentity);
    }

    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        paintValues(g);
    }

    public synchronized void processStatusItem(StatusItem item, String fullName)
    {
        String value = item.getValue();
        if (!statusItemValue.equals(value))
        {
            statusItemValue = value;
            repaint();
        }
    }
}