package nasa.stps.viewer.commands;
import javax.swing.KeyStroke;
import javax.swing.JOptionPane;
import java.awt.event.*;

/**
 * Handle the "exit" action.
 * @author Stan Hilinski, July 2001
 */
class ExitAction extends nasa.stps.library.XAction
{
    /** The parent JFrame. I use it for error dialogs. */
    private javax.swing.JFrame frame;

    ExitAction(javax.swing.JFrame frame)
    {
        super("Exit");
        this.frame = frame;
    }

    public final char getMnemonic()
    {
        return 'X';
    }

    public final KeyStroke getKeyStroke()
    {
        return KeyStroke.getKeyStroke(KeyEvent.VK_X,InputEvent.CTRL_MASK);
    }

    public final String getToolTip()
    {
        return "Exit the viwer";
    }

    public void actionPerformed(java.awt.event.ActionEvent e)
    {
        setEnabled(false);
        int x = JOptionPane.showConfirmDialog(frame,
                "Do you REALLY want to EXIT?",
                 "Information",JOptionPane.YES_NO_OPTION);

        if (x == JOptionPane.YES_OPTION)
        {
            System.exit(0);
        }
        else
        {
            setEnabled(true);
        }
    }
}