package nasa.stps.viewer.path;
import nasa.stps.viewer.status.Distributor;
import nasa.stps.viewer.StatusListPanel;

/**
 * PacketStatus shows status for one packet application id.
 * @author Stan Hilinski, August 2001
 */
class PacketStatus extends nasa.stps.viewer.StatusWindow
{
    private static final int VALUE_DIGITS = 10;
    private StatusListPanel slp;

    public PacketStatus(javax.swing.JFrame frame, String blockName,
            Distributor distributor)
    {
        super(frame, blockName, blockName + " Status");
        slp = new StatusListPanel(distributor, VALUE_DIGITS);
        setContentPane(slp);

        String x = blockName + ".";
        String item2 = x + "Packets Output";
        slp.addTextGadget("Packets Output",item2);
        slp.addAlarmGadget("Discarded Packets",x+"Discarded Packets",
                item2,0.1f,10f);
        slp.addAlarmGadget("Bad Lengths",x+"Bad Lengths",item2,0f,10f);
        slp.addAlarmGadget("Packets With Fill", x+"Packets With Fill",
                item2,0f,10f);
        slp.addAlarmGadget("Sequence Errors", x+"Sequence Errors",
                item2,0.1f,10f);
        slp.addTextGadget("Missing Packets",x+"Missing Packets");
        slp.addTextGadget("Bad Length Sample",x+"Bad Length Sample");
        slp.setGadgetsToSameSize();

        try { distributor.doStatus(); }
        catch (java.rmi.RemoteException re) {}

        pack();
    }

    public final void dispose()
    {
        /** disconnect the distributor */
        slp.disconnect();
        super.dispose();
    }
}
