package nasa.stps.viewer.tables;
import nasa.stps.viewer.status.Distributor;
import javax.swing.table.AbstractTableModel;

/**
 * This is a packet row in the packet status table.
 * @author Stan Hilinski, August 2001
 */
final class PacketStatusRow extends StatusRow
{
    static final String[] ID =
    {
        "Packets Output",
        "Sequence Errors",
        "Missing Packets",
        "Discarded Packets",
        "Bad Lengths",
        "Packets With Fill"
    };

    static final String[] HEADER =
    {
        "Output Pkts",
        "Seq Errors",
        "Missing",
        "Discarded",
        "Bad Sizes",
        "Pkts w/ Fill"
    };

    PacketStatusRow(AbstractTableModel tm, String blockName,
            Distributor distributor, int row)
    {
        super(tm,"packet",blockName,ID,distributor,row);
    }
}
