package nasa.stps.viewer.tables;
import nasa.stps.viewer.status.Distributor;

/**
 * This action lets the user create a packet status table window.
 * @author Stan Hilinski, August 2001
 */
public class PacketStatusTableAction extends StatusTableAction
{
    public PacketStatusTableAction(javax.swing.JFrame frame,
            nasa.stps.viewer.status.Distributor distributor)
    {
        super("Packet Status Table",frame,distributor);
        setMnemonic('A');
        setKeyStroke(java.awt.event.KeyEvent.VK_A);
        setToolTip("Show a packet status table for selected application ID.");
    }

    protected final java.util.List getBlockList()
    {
        return getBlockList("packet");
    }

    protected StatusTableModel createStatusTableModel(Distributor d)
    {
        return new PacketTableModel(d);
    }
}