package nasa.stps.viewer.tables;
import nasa.stps.viewer.status.Distributor;

/**
 * This class is the table model for the packet status table.
 * @author Stan Hilinski, August 2001
 */
final class PacketTableModel extends StatusTableModel
{
    /**
     * Create table model.
     */
    PacketTableModel(Distributor distributor)
    {
        super(distributor);
    }

    /**
     * Create a table row.
     */
    void createRow(int row, String fullBlockName)
    {
        String blockName = fullBlockName.substring(7);
        data.add(new PacketStatusRow(this,blockName,distributor,row));
    }

    /**
     * Use this method to finish configuration after all rows have been
     * created.
     */
    void configure()
    {
        String[] id = PacketStatusRow.HEADER;
        header = new String[id.length + 2];
        header[0] = "Type";
        header[1] = "Stream";
        for (int n = 0; n < id.length; n++)
        {
            header[n+2] = id[n];
        }
    }
}
