package nasa.stps.viewer.tables;
import nasa.stps.viewer.status.Distributor;
import javax.swing.JTable;

/**
 * StatusTable is a dialog window that shows a status table where each row
 * is one channel or stream.
 * @author Stan Hilinski, August 2001
 */
final class StatusTable extends nasa.stps.viewer.StatusWindow
{
    private StatusTableModel tableModel;

    StatusTable(String title, javax.swing.JFrame frame,
            String windowIdentity, Distributor distributor,
            StatusTableModel tableModel)
    {
        super(frame,windowIdentity,title);
        this.tableModel = tableModel;
        JTable table = new JTable(tableModel);
        table.setRowSelectionAllowed(false);
        table.setColumnSelectionAllowed(false);
        java.awt.Container cp = getContentPane();
        cp.add(table.getTableHeader(),"North");
        cp.add(table,"Center");
        try { distributor.doStatus(); }
        catch (java.rmi.RemoteException re) {}
        pack();
    }

    /**
     * Disconnect all listeners from the distributor.
     */
    public final void dispose()
    {
        tableModel.dispose();
        super.dispose();
    }
}