package nasa.stps.viewer.tables;
import nasa.stps.viewer.status.Distributor;

/**
 * This action lets the user create a virtual channel status table window.
 * @author Stan Hilinski, August 2001
 */
public final class VcStatusTableAction extends StatusTableAction
{
    private static final String[] typeNames = {"vcdu","bitstream","path"};

    public VcStatusTableAction(javax.swing.JFrame frame,
            nasa.stps.viewer.status.Distributor distributor)
    {
        super("Virtual Channel Status Table",frame,distributor);
        setMnemonic('V');
        setKeyStroke(java.awt.event.KeyEvent.VK_V);
        setToolTip("Show a status table for selected virtual channels.");
    }

    protected final java.util.List getBlockList()
    {
        return getBlockList(typeNames);
    }

    protected StatusTableModel createStatusTableModel(Distributor d)
    {
        return new VcTableModel(d);
    }
}